您的位置:首页 > 其它

codeforces 237 C. Primes on Interval

2016-10-23 16:08 447 查看
C. Primes on Interval

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

You've decided to carry out a survey in the theory of prime numbers. Let us remind you that a prime number is a positive integer that has exactly two distinct positive integer divisors.

Consider positive integers a, a + 1, ..., b (a ≤ b).
You want to find the minimum integer l (1 ≤ l ≤ b - a + 1) such
that for any integer x(a ≤ x ≤ b - l + 1) among l integers x, x + 1, ..., x + l - 1 there
are at least k prime numbers.

Find and print the required minimum l. If no value l meets
the described limitations, print -1.

Input

A single line contains three space-separated integers a, b, k (1 ≤ a, b, k ≤ 106; a ≤ b).

Output

In a single line print a single integer — the required minimum l. If there's no solution, print -1.

Examples

input
2 4 2


output
3


input
6 13 1


output
4


input
1 4 3


output
-1


题解:素数筛+前缀和求值sum[i]+二分。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#define maxn 1000010
using namespace std;
int su[maxn],sum[maxn];
int a,b,k;
void Prime()
{
memset(su,0,sizeof(su));
su[0]=1;
su[1]=1;
for(int i=2;i<maxn;i++)
{
if(su[i])
continue;
else
{
for(int j=i*2;j<maxn;j+=i)
su[j]=1;
}
}
}
bool judge(int x)
{
int i;
for(i=a;i<=b-x+1;i++)
{
if(sum[i+x-1]-sum[i-1]<k)
return 0;
}
return 1;
}
int main()
{
Prime();
sum[1]=0;
for(int i=2;i<maxn;i++)
{
sum[i]=sum[i-1];
if(!su[i])
sum[i]++;
}
scanf("%d%d%d",&a,&b,&k);
int l=0,r=b-a+1,mid,ans=-1;
while(l<=r)
{
mid=(l+r)/2;
if(judge(mid))
{
ans=mid;
r=mid-1;
}
else
l=mid+1;
}
printf("%d\n",ans);
return 0;
}

2016/12/10

再次写这道题,先是题意又理解错了,x(a ≤ x ≤ b - l + 1),在x, x + 1, ..., x + l - 1上至少有k个素数

写成r=mid;和l=mid就TE!!!改成r=mid-1;和l=mid+1;就AC!!!!

代码同上(因为是又看了以前的才发现这次的错误
呜)
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: